package com.jswett;

import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * @author Joshua Swett
 *
 */
public class TestCase {

    public String runCase() throws NamingException {
        InitialContext ctx = null;

        try {
            ctx = new InitialContext();

            TestEJBRemote ejb = (TestEJBRemote) ctx.lookup("ejb:/TestWAR//TestEJB!com.jswett.TestEJBRemote");
            DummySerializableObject dummy = new DummySerializableObject();

            String objectRefOutside = dummy.toString();
            String objectRefInside = ejb.getObjectReference(dummy);

            StringBuilder sb = new StringBuilder("<b>Object reference outside of EJB call:</b> " + objectRefOutside);
            sb.append("<br/><b>Object reference inside of EJB call:</b> " + objectRefInside);
            sb.append("<br/><br/>");

            if (objectRefInside.equals(objectRefOutside)) {
                sb.append("The object references are the same! By default, it should be passing by value, not reference");
            } else {
                sb.append("The object references are different... this is correct default behavior");
            }

            return sb.toString();
        } catch (NamingException ne) {
            return "Test case failed due to NamingException :( See server logs.";
        } finally {
            if (ctx != null) {
                ctx.close();
            }
        }
    }
}
